<?php

	/**********************************************
	*	index.php - Author: Samnan ur Rehman       *
	*	This file is a part of MyWebSQL package    *
	*	PHP5 compatible                            *
	**********************************************/

	header("Content-Type: text/html;charset=utf-8");
	session_start();

	include ("config/themes.php");
	include_once ("config/config.php");

	function_exists('ob_gzhandler') ? ob_start("ob_gzhandler") : ob_start();
	ob_implicit_flush(0);

	if (defined("TRACE_FILEPATH") && TRACE_FILEPATH && TRACE_MESSAGES)
		ini_set("error_log", TRACE_FILEPATH);

	include_once("lib/util.php");
	include_once(getDBClass());
	$DB = new DbManager();

	require('modules/auth.php');
	$auth_module = new MyWebSql_Authentication();
	if (!$auth_module->authenticate($DB))
	{
		include("modules/splash.php");
		die(getSplashScreen($auth_module->getError()));
	}

	// from here on everything is well and set to start working
	/*if (v($_REQUEST["conn"]))
	{
		$_SESSION["init"] = 0;
		$_SESSION["dbver"] = "";
	}*/

	if (v($_REQUEST["db"]) && ( v($_SESSION["db"]) != v($_REQUEST["db"]) ) )
	{
		$_dbChanged = true;
		$_SESSION["db"] = $_REQUEST["db"];
	}

	if (v($_REQUEST["q"]) == "wrkfrm")
	{
		if (!$DB->connect(DB_HOST, DB_USER, DB_PASS, getDbName() ))
			die(showDBError());
		if (v($_REQUEST["type"]) == "dl")			// downloads
		{
			include("modules/download.php");
			handleDownload($DB);
		}
		else
			doWork($DB);							// usual stuff
		$DB->disconnect();
		print_gzipped_output();
		exit();
	}

	define("RIGHT_ALIGN", "right");
	define("LEFT_ALIGN", "left");
	define("IMAGE_PATH", "img");
	include("lib/html.php");
	include("lib/interface.php");
	$HTML = new HTML();
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset='utf-8';" />
<title>MyWebSql</title>
	<link rel="stylesheet" type="text/css" href="cache.php?css=theme,default" />
	<script type="text/javascript" language="javascript" src="cache.php?script=jquery,layout,ui,context,alerts,position,cookies"></script>
	<link rel="SHORTCUT ICON" href="favicon.ico" />
	<link rel="stylesheet" type="text/css" href="cache.php?css=menu,iktree,treeview,results,context,alerts" />
</head>
<body>
<?php
	if (!$DB->connect(DB_HOST,DB_USER,DB_PASS,getDbName()))
	{
		include("modules/splash.php");
		die(getSplashScreen(showDBError()));
	}
?>
	<div id="editToolbar" style="position:absolute;display:none;z-index:20000">
		<table border="0">
			<tr>
				<td nowrap="nowrap">Edit options: [ Press Shift + <?php echo $KEY_CODES['KEYCODE_SETNULL'][1];?> to set NULL ]
				</td>
			</tr>
		</table>
	</div>

	<div class="ui-layout-north">
		<img src="img/logo.gif" alt="MyWebSql" width="200" height="47" style="padding-top:3px;padding-bottom:3px" />
	<div id="toolbarHolder">

<?php
		include_once ("lib/menu.php");
		include_once ("lib/iktree.php");
		createMenuBar();
?>
	</div>
</div>

<div class="ui-layout-west">

	<div class="ui-state-default" style="padding-left:3px; padding-right:3px;padding-top:2px;padding-bottom:2px;text-align: left; margin: 0px; top:0px;position:absolute;left:0;right:0">
		<?php $db_list = printDbList($DB, $HTML); ?>
	</div>

	<div style="padding: 0px; text-align:left; margin:0px; top:24px;bottom:0px;position:absolute;left:0;right:0;overflow:auto;background:white;border:1px solid #AED0EA">
		<?php createDatabaseTree($DB, $db_list); ?>
	</div>

</div>

<div class="ui-layout-center">
	<div id="screenContent" class="ui-layout-data-center">
		<ul>
			<li><a href="#tab-results" id="headerResults">Results</a></li>
			<li><a href="#tab-messages" id="headerMessages">Messages</a></li>
			<li><a href="#tab-info" id="headerInfo">Information</a></li>
			<li><a href="#tab-history" id="headerHistory">History</a></li>
		</ul>

		<div class="ui-layout-content ui-corner-bottom">
			<div id="tab-results">
				<div style="padding:20px">There are no results to show in this view.</div>
			</div>
			<div id="tab-messages">
				&nbsp;
			</div>
			<div id="tab-info" class="ui-widget">
                <?php createBasicInfoPage($DB, $HTML); ?>
   			</div>
			<div id="tab-history">
                <table id="sql-history"><tbody><tr><td></td></tr></tbody></table>
			</div>
		</div>
	</div>
	<div class="ui-layout-data-south">

		<div class="ui-state-default" style="position:absolute;top:0px;left:0;right:0;padding:4px 0px 4px 10px;text-align:left;margin:0px;">
			Sql Editor
		</div>

		<div class="ui-state-default" style="padding: 0px; text-align:left; margin:0px; top:24px;bottom:21px;position:absolute;left:0;right:0;overflow:hidden">
			<textarea class="sqlEditor" id="commandEditor" name="commandEditor" rows="5" cols="40"></textarea>
		</div>

		<div id="nav_bar" class="footer ui-state-default">
			<button id="nav_queryall">Query All</button>
			<button id="nav_query">Query</button>
			<button id="nav_delete">Delete records</button>
			<button id="nav_update">Update records</button>
		</div>
	</div>
</div>

<div class="ui-layout-south">
	<table width="100%" border="0" cellpadding="0" cellspacing="0" class="ui-dialog-statusbar ui-widget-statusbar">
		<tr>
			<td id="recordCounter" class="footer">&nbsp;</td>
			<td id="timeCounter" class="footer">&nbsp;</td>
			<td id="loadingContainer" class="footer">
				<img id="loaderImg" src="themes/<?php echo THEME_PATH; ?>/images/loading.gif" alt="Loading ..." />
			</td>
			<td id="messageContainer" class="footer">Please wait ...</td>
		</tr>
	</table>
</div>
<!--dialogs-->
<div id="dialog" title="Dialog">
	<div id="dialog_msg" class="ui-widget ui-state-highlight ui-corner-all" style="margin:5px; padding:5px">Please wait ...</div>
	<iframe src="index.php?q=wrkfrm" name="dialog_contents" id="dialog_contents" frameborder="0"></iframe>
</div>
<div id="dialog-dbcreate" class="scrinfo" title="Create Database">
	<div class="padded">
	<form name="dbform" action="" method="get">
		<div>
			<label for="dbname">Database name:</label>
			<input type="text" name="dbname" id="dbname" class="text" /><br/>
		</div>
		<div>
			<input type="checkbox" name="dbselect" id="dbselect" class="text ui-widget-content" />
			<label for="dbselect">Select database after creation</label>
		</div>
	</form>
	</div>
</div>
<!--/dialogs-->
<iframe src="index.php?q=wrkfrm" name="wrkfrm" id="wrkfrm" frameborder="0" width="0" height="0"></iframe>
<?php
	if (v($_dbChanged))
		$HTML->scriptText("document.getElementById('messageContainer').innerHTML = 'Database changed to: ".$_SESSION["db"]."';");
	else
		$HTML->scriptText("document.getElementById('messageContainer').innerHTML = 'Connected to: ".DB_HOST." as ".DB_USER."';");
?>
	<script type="text/javascript" language="javascript" src="cache.php?script=interface,menu,treeview,common,options,query,tables,sorttable,browser"></script>
	<script type="text/javascript" language="javascript">
		var THEME_PATH = "<?php echo THEME_PATH;?>";
		var EXTERNAL_PATH = "<?php echo EXTERNAL_PATH; ?>";
		var sqlEditMode = "<?php echo getSqlEditorType(); ?>";
		var commandEditor = null;
<?php
	foreach($KEY_CODES as $name=>$code)
		echo "\t".'var '.$name.' = "'.$code[0].'";'."\n";
?>
	</script>
<?php
	createContextMenus();

	updateSqlEditor($HTML);

	$HTML->endbody();

	$DB->disconnect();

	print_gzipped_output();
?>