/********************************************************************
 *	browser.js - Author: Samnan ur Rehman							*
 *	This file is a part of MyWebSQL package							*
 ********************************************************************/

/* Thanks to www.quirksmode.org */

var browser = {
	init: function () {
		this.browser = this.searchString(this.dataBrowser) || "unknown";
		this.version = this.searchVersion(navigator.userAgent)
			|| this.searchVersion(navigator.appVersion)
			|| "0";
		this.OS = this.searchString(this.dataOS) || "unknown";
		
		/* added by Sam */
		this.name = (this.browser == "Explorer") ? "Internet Explorer" : this.browser;	// user friendlier name
		this.isIE = (this.browser == "Explorer");
		this.isChrome = (this.browser == "Chrome");
		this.isFirefox = (this.browser == "Firefox");
		this.isSafari = (this.browser == "Safari");
		this.isOpera = (this.browser == "Opera");
	},
	searchString: function (data) {
		for (var i=0;i<data.length;i++)	{
			var dataString = data[i].string;
			var dataProp = data[i].prop;
			this.versionSearchString = data[i].versionSearch || data[i].identity;
			if (dataString) {
				if (dataString.indexOf(data[i].subString) != -1)
					return data[i].identity;
			}
			else if (dataProp)
				return data[i].identity;
		}
	},
	searchVersion: function (dataString) {
		var index = dataString.indexOf(this.versionSearchString);
		if (index == -1) return;
		return parseFloat(dataString.substring(index+this.versionSearchString.length+1));
	},
	dataBrowser: [
		{
			string: navigator.userAgent,
			subString: "Chrome",
			identity: "Chrome"
		},
		{ 	string: navigator.userAgent,
			subString: "OmniWeb",
			versionSearch: "OmniWeb/",
			identity: "OmniWeb"
		},
		{
			string: navigator.vendor,
			subString: "Apple",
			identity: "Safari",
			versionSearch: "Version"
		},
		{
			prop: window.opera,
			identity: "Opera"
		},
		{
			string: navigator.vendor,
			subString: "iCab",
			identity: "iCab"
		},
		{
			string: navigator.vendor,
			subString: "KDE",
			identity: "Konqueror"
		},
		{
			string: navigator.userAgent,
			subString: "Firefox",
			identity: "Firefox"
		},
		{
			string: navigator.vendor,
			subString: "Camino",
			identity: "Camino"
		},
		{		// for newer Netscapes (6+)
			string: navigator.userAgent,
			subString: "Netscape",
			identity: "Netscape"
		},
		{
			string: navigator.userAgent,
			subString: "MSIE",
			identity: "Explorer",
			versionSearch: "MSIE"
		},
		{
			string: navigator.userAgent,
			subString: "Gecko",
			identity: "Mozilla",
			versionSearch: "rv"
		},
		{ 		// for older Netscapes (4-)
			string: navigator.userAgent,
			subString: "Mozilla",
			identity: "Netscape",
			versionSearch: "Mozilla"
		}
	],
	dataOS : [
		{
			string: navigator.platform,
			subString: "Win",
			identity: "Windows"
		},
		{
			string: navigator.platform,
			subString: "Mac",
			identity: "Mac"
		},
		{
			   string: navigator.userAgent,
			   subString: "iPhone",
			   identity: "iPhone/iPod"
	    },
		{
			string: navigator.platform,
			subString: "Linux",
			identity: "Linux"
		}
	]

};

browser.init();

function addEventList(ev, fn)
{
	if (browser.isIE)
		document.attachEvent("on"+ev, fn);
	else
		document.addEventListener(ev, fn, true);
}

function removeEventList(ev, fn)
{
	if (browser.isIE)
		document.detachEvent("on"+ev, fn);
	else
		document.removeEventListener(ev, fn, true);
}

function preventBubbling(event)
{
	if (browser.isIE)
	{
		window.event.cancelBubble = true;
		window.event.returnValue = false;
	}
	else
		event.preventDefault();
}

function getElemTopLeft(obj)
{
	x = 0, y = 0;
	while( obj != null )// && obj != document)
	{
		x += obj.offsetLeft;
		y += obj.offsetTop;
		obj = obj.parentElement;
	}
	return new Array(x, y);
}

/* add a browser specific css to this browser, if it exists */
//var doc = document.getElementsByTagName('head').item(0);
//css = document.createElement("link");
//css.rel = "stylesheet";
//css.href = "css/" + browser.browser.toLowerCase() + ".css";
//doc.appendChild(css);
