/********************************************************************
 *	interface.js - Author: Samnan ur Rehman							*
 *	This file is a part of MyWebSQL package							*
 ********************************************************************/

var main_layout;
var data_layout;
var commandEditor;

$(document).ready(function () {

	$('body').bind('contextmenu', function() { return false; });
	$('#dialog_contents').bind('load', function() { updatePopup(1); });

	$(".ui-layout-data-center")
			.tabs();

	main_layout = $('body').layout(
		{
			north__resizable: false
			,north__closable: false
			,south__resizable: false
			,south__closable: false
			,west__minSize: 150
			,west__size: $('body').innerWidth() * 0.2
			,east__minSize: 200
			,center__onresize:		"data_layout.resizeAll"
	});

	data_layout = $('div.ui-layout-center').layout(
		{
			center__paneSelector:		".ui-layout-data-center"
			,south__paneSelector:		".ui-layout-data-south"
			,center__resizable: true
			,south__resizable: true
			,south__closable: true
			,south__minSize: 72
			,south__size: 160
			,onresize_start: function() { if (sqlEditMode == 1) $(".sqlEditFrame").css("display", "none"); }
			,onresize_end: function() { if (sqlEditMode == 1) $(".sqlEditFrame").css("display", "block"); }
		});

	main_layout.allowOverflow('north');
	if (sqlEditMode != 1)
		initStart();

	//$("#loadingContainer").progressbar({ value:100 });

	$("#dialog").dialog({
		//bgiframe: true,
		autoOpen: false,
		width:500,
		height: 300,
		modal: true
		});

	$("#dialog-dbcreate").dialog({
		autoOpen: false,
		width:320,
		height: 160,
		modal: true,
		buttons: {
			Cancel: function() {
				$(this).dialog('close');
			},
			'Create Database': function() {
				name = $.trim($('#dbname').val());
				if (name != '')
				{
					wrkfrmSubmit("dbcreate", "", name, $('#dbselect').attr('checked') ? '1' : '0');
					$(this).dialog('close');
				}
			}
		}
	});

	$('.ui-dialog').bind('resize', function(){
		$('#dialog_contents').height($(this).height()).width($(this).width());
	});

	$(".ui-layout-data-center").tabs('select', 2);

	$("#tablelist").treeview();

	contextHandler();

	// chrome selection issue fix when a resizer is used for rsizing
	$('.ui-layout-resizer').bind('selectstart', function() { return false; });

	$('#nav_query').button({
			text: true,	icons: {primary: 'ui-icon-play'}
		}).click(function() { queryGo(0); });
	$('#nav_queryall').button({
			text: true,	icons: {primary: 'ui-icon-seek-end'}
		}).click(function() { queryGo(1); });
	$('#nav_delete').button({
			text: true,	icons: {primary: 'ui-icon-close'}
		}).click(function() { queryDelete(); });
	$('#nav_update').button({
			text: true,	icons: {primary: 'ui-icon-disk'}
		}).click(function() { querySave(); });
	//main_layout.load('layout');
});

function contextHandler()
{
	if(typeof db_tables == "object")
	{
		for(i=0;i<db_tables.length; i++)
			$("#t_" + db_tables[i]).contextMenu(mnu_ikMenuTable);
	}
	if(typeof db_views == "object")
	{
		for(i=0;i<db_views.length; i++)
			$("#t_" + db_views[i]).contextMenu(mnu_ikMenuView);
	}
	if(typeof db_procs == "object")
	{
		for(i=0;i<db_procs.length; i++)
			$("#t_" + db_procs[i]).contextMenu(mnu_ikMenuProc);
	}
	if(typeof db_funcs == "object")
	{
		for(i=0;i<db_funcs.length; i++)
			$("#t_" + db_funcs[i]).contextMenu(mnu_ikMenuFunc);
	}
	if(typeof db_trigs == "object")
	{
		for(i=0;i<db_trigs.length; i++)
			$("#t_" + db_trigs[i]).contextMenu(mnu_ikMenuTrig);
	}

	$("#sql-history").contextMenu( mnu_editHst );

	document.getElementById('divBr1').innerHTML = browser.name;
	document.getElementById('divBr2').innerHTML = browser.version;
	setPageStatus(false, '');

	if (browser.isOpera)
		$("#tab-info").append('<div class="ui-widget ui-state-highlight ui-corner-all" style="padding:5px;margin-top:40px"><span class="ui-icon ui-icon-info" style="float:left;margin-right:8px;"></span><p>Some versions of Opera browser do not allow webpages to properly recieve context menu and right click events. You may experience reduced functionality during this session.</p></div>');
}

// sql editor special purpose key handlers
function editHandler(k)
{
    if ( typeof(k) == 'object' && (k.keyCode == KEYCODE_QUERY || k.keyCode == KEYCODE_QUERYALL) )
	{
	   if (k.ctrlKey || k.shiftKey)
            return false;
		queryGo(k.keyCode == KEYCODE_QUERYALL ? 1 : 0);
		return true;
	}
	return false;
}

function editHandler2(k)
{
	if (k == KEYCODE_QUERY || k == KEYCODE_QUERYALL)
		return true;
	return false;
}

//$(window).unload(function(){ main_layout.save('layout') });