/********************************************************************
 *	menu.js - Author: Samnan ur Rehman							*
 *	This file is a part of MyWebSQL package							*
 ********************************************************************/

document.onclick = menuHideOnCLick;
var menuCloseOnClick = false;
var expandMenu = false;
var menuLastId = -1;
var menuSectionid = -1;
var menuLastSubid = -1;
var ikCMenuHover = false;
var ikCMenuId = null;
var ikCMenuObj = null;

function menuHideOnCLick()
{
	if(menuCloseOnClick && menuLastId != -1)
	{
		hideMenu(menuLastId);
		expandMenu = false;
	}
}

function menuOnClickHandler(funWithParam)
{	
	if(menuLastId != -1)
		hideMenu(menuLastId);
	
	eval(funWithParam);
	expandMenu = false;
}

function toggleMenu(id)
{
	expandMenu = !expandMenu;
	if(expandMenu)
	{
		showMenu(id);
	}
	else
	{
		hideMenu(id);
		document.getElementById('menuButton' + id).className = "menu-button_hover";
	}
	menuCloseOnClick = false;
}

function showMenu(id)
{
	if(expandMenu)
	{	
		document.getElementById('menuButton' + id).className = "menu-button_active";
		document.getElementById('menuItem' + id).style.display = 'block';
		
		menuLastId = id;
		menuSectionid = id;
		
		if (document.getElementById("dblist"))			// IE 6 fix
			document.getElementById("dblist").style.visibility = "hidden";
	}
}

function hideMenu(id)
{
	hideSubMenu();
	obj = document.getElementById('menuItem' + id);
	if(obj)
	{
		obj.style.display = 'none';
		document.getElementById('menuButton' + id).className = "menu-button";
	}
	menuLastId = -1;
	
	if (document.getElementById("dblist"))			// IE 6 fix
			document.getElementById("dblist").style.visibility = "visible";
}

function menuHover(id) 
{
	document.getElementById('menuButton' + id).className = "menu-button_hover";
	if(menuLastId != -1)
		hideMenu(menuLastId);
	
	showMenu(id);
	menuCloseOnClick = false;
}

function menuHout(id) 
{
	if(menuLastId != id)
		document.getElementById('menuButton' + id).className = "menu-button";
	menuCloseOnClick = true;
}

function menuItemHover(obj, subItem) 
{
	if(obj.className != "disabled")
		obj.className = "ikCMenuItmH";
	
	if(!subItem)
		hideSubMenu();

	menuCloseOnClick = false;
}

function menuItemHout(obj) 
{
	obj.className = "ikCMenuItm";
	menuCloseOnClick = true;
}

function showSubMenu(obj, id)
{
	obj.className = "subMenu_hover";
	
	if(menuLastSubid != id)
		hideSubMenu();
		
	section = document.getElementById('menuItem'+ menuSectionid);
	subMenu = document.getElementById('submenuItem' + id);
	
	subMenu.style.left = section.offsetLeft + section.offsetWidth;
	subMenu.style.top  = section.offsetTop + document.getElementById('subSection'+ id).offsetTop + 2;
	
	subMenu.style.display = 'block';
	menuLastSubid = id;
	
	menuCloseOnClick = false;
}

function hideSubMenu()
{
	if(menuLastSubid > -1)
	{
		obj = document.getElementById('subSection'+ menuLastSubid);
		if(obj)
		{
			obj.className = "subMenu";
			document.getElementById('submenuItem' + menuLastSubid).style.display = 'none';
		}
		menuLastSubid = -1;
	}
}

function showNavBtns()
{
	bn = new Array("query", "queryall", "delete", "update");
	for(i=0; i<bn.length; i++)
		$('#nav_' + bn[i]).css("display", "none");

	for(i=0; i<arguments.length; i++)
		$('#nav_' + arguments[i]).css("display", "block");
}

function showNavBtn(btn)
{
	$('#nav_' + btn).css("display", "block");
}

function hideNavBtn(btn)
{
	$('#nav_' + btn).css("display", "none");
}

function ikCMenuHv(obj, flg)
{
	if (flg)
		obj.className = "ikCMenuItmH";
	else
		obj.className = "ikCMenuItm";
}

function ikHideCMenu()
{
	//if (ikCMenuHover == false || (window.event && event.srcElement && event.srcElement.className == "ikCMenuItmH"))
	if (ikCMenuId && document.getElementById(ikCMenuId))
	{
		document.getElementById(ikCMenuId).style.display = "none";
		removeEventList("onclick", ikHideCMenu);
	}
}