/**********************************************************
 *	query.js - Author: Samnan ur Rehman                   *
 *	This file is a part of MyWebSQL package               *
 **********************************************************/

var _init = false;
var resultInfo = "";          // saves info of edited result set during editing
var editTableName = "";       // name of editing table from where the result came up
var numEditRecords = 0;       // number of edited records
var editKey = "";             // unique or pirmary key for editing
var numRecords = 0;           // number of records fetched
// caret variables
var clickx = 0, clicky = 0;
// var dataTable = null; @todo: remove from final build

// user preferences
var prf_limitRecords;         //, prf_edHright, prf_objWidth;

function initStart()
{
	if (_init)
		return true;
	_init = true;
	loadUserPreferences();
	if (sqlEditMode == 0)
		commandEditor = $("#commandEditor");
	x = $.cookies.get("sql_commandEditor");
	if (x)
		setSqlCode(x);
	showNavBtns('query', 'queryall');
	commandEditor.focus();

	// @todo: fix with new codemirror
	//if (browser.isFirefox)     // so far only one browser compatible with this
	//	commandEditor.grabKeys(editHandler, editHandler2);
}

function helpShowAll()
{
	openPopupDiv("?q=wrkfrm&type=help", 580, 380);
}

function helpReportBug()
{
	openPopupDiv("?q=wrkfrm&type=bugreport", 440, 320);
}

function dbRefresh()
{
	window.location.reload();
}

function dbCreate()
{
	$('#dbname').val('');
	$('#dbselect').attr('checked', false);
	$('#dialog-dbcreate').dialog('open');
}

function getTableName()
{
	x = ikCMenuObj.getElementsByTagName("tbl");
	return (x[0].title);	// only id and title is the thing mozilla can give.. it does not give back name

}

function getResults(i)
{
	if (browser.isIE)
		xfrm = document.frames('wrkfrm');
	else
		xfrm = window.frames['wrkfrm'];
	if (i == 0)
	{
		if (xfrm.document.getElementById('results').innerText)		// IE
			x = xfrm.document.getElementById('results').innerText;
		else if (xfrm.document.getElementById('results').textContent)	//firefox
			x = xfrm.document.getElementById('results').textContent;
		else
			x = xfrm.document.getElementById('results').innerHTML;
	}
	else if (i == 1)
		x = xfrm.document.getElementById('results').innerHTML;

	xfrm.document.getElementById('results').innerHTML = "";
	return x;
}

function tableSelect(tbl)
{
	delim = ";\n";
	st = delim + "select * from `" + tbl + "`";
	setSqlCode( st, 1 );
}

function tableInsert(tbl)
{
	setPageStatus(true, "");
	wrkfrmSubmit("tableinsert", "", tbl);
}

function tableUpdate(tbl)
{
	setPageStatus(true, "");
	wrkfrmSubmit("tableupdate", "", tbl);
}

function tableDescribe(tbl)
{
	setPageStatus(true, "");
	wrkfrmSubmit("query", "", "", "describe `" + tbl + "`");
}

function tableViewData(tbl)
{
	setPageStatus(true, "");
	q = "select * from `" + tbl + "` limit 0," + prf_limitRecords;
	delim = ";\n";
	setSqlCode(delim + q, 1);

	wrkfrmSubmit("query", "", "", q);
}

function showCreateCmd(type, tbl)
{
	setPageStatus(true, "");
	wrkfrmSubmit("showcreate", type, tbl, "");
}

function tableSel(t)
{
	//ikSelectItem("tb_" + t);
}

function viewSel(t)
{
	//ikSelectItem("vw_" + t);
}

function procSel(t)
{
	//ikSelectItem("pr_" + t);
}
function funcSel(t)
{
	//ikSelectItem("fn_" + t);
}
function trigSel(t)
{
	//ikSelectItem("tg_" + t);
}

function queryGo(type)
{
	editData = null;		// flush out editing
	strQuery = getSqlCodeSelection();
	if (strQuery == "")
		strQuery = getSqlCode();

	if ($.trim(strQuery) == "")
	{
		jAlert("Please type in one or more queries in the sql editor !", "Execute query", function() { commandEditor.focus(); });
		return;
	}
	querySaveCache(strQuery);

	if (type == 1)
	{
		if (confirm("Are you sure you want to execute all (selected) queries ?"))
		{
			setPageStatus(true, "Please wait ...");
			wrkfrmSubmit("queryall", "", "", strQuery);
		}
	}
	else
	{
		setPageStatus(true, "Please wait ...");
		wrkfrmSubmit("query", "", "", strQuery);
	}

	commandEditor.focus();
}

function queryDelete()
{
	if(typeof document.resForm != "object" || typeof document.resForm.ckr != "object")
		return;

	qBig = "";
	if(document.resForm.ckr.length)
	{
		for(i=0; i<document.resForm.ckr.length; i++)
			if(document.resForm.ckr[i].checked)
				qBig += makeDeleteClause(i);
	}
	else if (document.resForm.ckr.checked)
		qBig = makeDeleteClause(0);

	setSqlCode( qBig, 1 );

	showNavBtns('query', 'queryall');
}

function querySave()
{
	if (editData == null)
		return;

	delim = ";\n";
	qBig = "";
	for(i=0; i<editData.length; i++)
	{
		upd = "update "+ editTableName + " set ";
		st = "";
		whr = "";
		if (typeof editData[i] != "object")
			continue;

		for(j=0; j<editData[i].length; j++)
		{
			if (typeof editData[i][j] == "object")
			{
				f = getFieldName(j);
				if (editData[i][j].setNull)
					dta = "NULL,";
				else
					dta = '"' + editData[i][j].value.replace(/\\/g,"\\\\").replace(/\"/g,"\\\"") + '",';
				st += "`" + f + "`=" + dta ;
			}
		}
		whr = makeWhereClause(i);
		st = st.substr(0, st.length-1);
		qBig += delim + upd + st + whr;
	}

	setSqlCode( qBig, 1);

	editData = new Array();

	showNavBtns('query', 'queryall');
}

function transferBlobData()
{
	updatePopupTitle('Blob/Text data');
}

function transferQuery()
{
	delim = ";\n";
	htm = delim + getResults(0);
	setSqlCode(htm, 1);

	setPageStatus(false);

	commandEditor.focus();
}

function transferResultMessage(num, tm, msg)
{
	resultInfo = "";
	$("#tab-messages").html(getResults(1));
	document.getElementById("timeCounter").innerHTML = tm;
	document.getElementById("messageContainer").innerHTML = msg;

	setPageStatus(false);
	showNavBtns('query', 'queryall');

	$(".ui-layout-data-center").tabs('select', 1);
	$("#tab-info").attr("scrollTop", 0);
}

function transferResultGrid(num, tm, msg)
{
	resultInfo = "";
	// must add form here. FireFox removes form element if taken from div's innerHTML (no idea why)
	$("#tab-results").html("<form name='resForm' method='post' action='#' onsubmit='return false;'>" + getResults(1) + "</form>");
	if (num == -1)
		document.getElementById("recordCounter").innerHTML = "&nbsp;";
	else
		document.getElementById("recordCounter").innerHTML = num + " record(s)";
	document.getElementById("timeCounter").innerHTML = tm;
	document.getElementById("messageContainer").innerHTML = msg;

	if (editTableName == "")
		$("#headerResults").html("Results");
	else
		$("#headerResults").html("Results from " + editTableName);

	numRecords = num;
	setPageStatus(false);
	showNavBtns('query', 'queryall');

	if(num > 0)
		setupResults();

	$(".ui-layout-data-center").tabs('select', 0);
	$("#tab-results").attr("scrollTop", 0);

}

function getFieldInfo(num)
{
	return fieldInfo[num];
}

function getFieldName(num)
{
	return fieldInfo[num]['name'];
}

function makeWhereClause(num)
{
	str = " where ";
	x = document.getElementById("rc" + num);

	if (editKey == ",")
	{
		for(m=0; m<fieldInfo.length; m++)
		{
			val = x.childNodes[m+2].innerHTML;
			if (x.childNodes[m+2].defText)
				val = x.childNodes[m+2].defText;
			str += getFieldName(m) + "='" + val + "' and ";
		}
	}
	else
	{
		for(m=0; m<fieldInfo.length; m++)
		{
			if (editKey.indexOf(","+getFieldName(m)+",") != -1)
			{
				val = x.childNodes[m+2].innerHTML;
				if (x.childNodes[m+2].defText)
					val = x.childNodes[m+2].defText;
				str += getFieldName(m) + "='" + val + "' and ";
			}
		}
	}

	return str.substr(0, str.length - 5);
}

function makeDeleteClause(num)
{
	delim = ";\n";
	str = delim + "delete from `" + editTableName + "` where ";
	x = document.getElementById("rc" + num);

	for(m=0; m<fieldInfo.length; m++)
	{
		if (editKey.indexOf(getFieldName(m)) != -1)
		{
			val = x.childNodes[m+2].innerHTML;
			if (x.childNodes[m+2].defText)
				val = x.childNodes[m+2].defText;
			str += getFieldName(m) + "='" + val + "' and ";
		}
	}

	return str.substr(0, str.length - 5);
}

/* *************************************************** */
function querySaveCache()
{
	$.cookies.set("sql_commandEditor", getSqlCode(), {path: EXTERNAL_PATH});
}

function vwBlb(id, name, btype)
{
	openPopupDiv("?q=wrkfrm&type=viewblob&id="+id+"&name="+name+"&blobtype="+btype, 600, 500);
}

/* only for debugging */
function debugObject(obj)
{
	var attrs = '';
	for( var attr in obj )
	{
		attrs += attr+'=' + obj[attr] + '\n';
	}
	alert( attrs );
}
/* only for debugging */

function loadUserPreferences()
{
	prf_limitRecords = parseInt($.cookies.get("prf_limitRecords"));

	if (!prf_limitRecords)
		prf_limitRecords = 100;
}

function dbObjectCreate(id)
{
	openPopupDiv("?q=wrkfrm&type=objcreate&id="+id, 535, 430);
}

function dbCreateTable()
{
	openPopupDiv("?q=wrkfrm&type=createtbl", 760, 460);
}

/* ******************************** */
function toolsOptions()
{
	openPopupDiv("?q=wrkfrm&type=options", 500, 260);
}

function selectDatabase()
{
	db = (arguments.length == 1) ? "?db=" + arguments[0] : "?db=" + document.getElementById("dblist").options[document.getElementById("dblist").selectedIndex].text;
	window.location.href = db;
}

function resultSelectAll()
{
	for(i=0; i<document.resForm.ckr.length; i++)
		document.resForm.ckr[i].checked = document.resForm.ckrAll.checked;

	document.resForm.ckrAll.checked ? showNavBtn('delete') : hideNavBtn('delete');
}

function getSqlCode()
{
	if (sqlEditMode == 0)
		return document.getElementById("commandEditor").value;

	return commandEditor.getCode();
}

function setSqlCode(s, u)
{
	if (sqlEditMode == 0)
	{
		document.getElementById("commandEditor").value = (u==1) ? document.getElementById("commandEditor").value + s : s;
		return;
	}

	commandEditor.setCode( ((u==1) ? commandEditor.getCode() + s : s) );
}

function getSqlCodeSelection()
{
	if (sqlEditMode == 0)
	{
		if (! document.selection)
			return "";
		tr = document.selection.createRange();
		return tr.text;
	}

	return commandEditor.selection();
}

/* ********************************* */
function dataImport()
{
	openPopupDiv("?q=wrkfrm&type=import", 500, 320);
}

function resultsExport()
{
	if (numRecords == 0)
		jAlert("There is no record in the results to export", "Exports results");
	else
		openPopupDiv("?q=wrkfrm&type=exportres", 500, 320);
}

function dataExport()
{
	openPopupDiv("?q=wrkfrm&type=export", 500, 360);
}

function tableExport(tbl)
{
	openPopupDiv("?q=wrkfrm&type=exporttbl&table="+tbl, 500, 320);
}

function getSelRecCount()
{
	if(typeof document.resForm != "object" || typeof document.resForm.ckr != "object")
		return -1;

	j = 0;
	if(document.resForm.ckr.length)
	{
		for(i=0; i<document.resForm.ckr.length; i++)
			if(document.resForm.ckr[i].checked)
				j++;
	}
	return j;
}

function toolsProcManager()
{
	openPopupDiv("?q=wrkfrm&type=processes", 560, 380);
}

function toolsVariables()
{
	openPopupDiv("?q=wrkfrm&type=variables", 580, 380);
}

function makeFieldNull()
{
	if (editToolbarTimer != null)
		clearTimeout(editToolbarTimer);
}

function historyCopy(obj)
{
	txt = "";
	obj.children(".hst").each( function() { txt += $(this).html() + "\n";} );
	if( window.clipboardData && clipboardData.setData )
		clipboardData.setData("text", txt);
}

function historyClear(obj)
{
	obj.hide();
	if (confirm("Clear command history ?"))
		$("#sql-history").html("<tbody></tbody>");
}

function setupResults()
{
	setupTable('dataTable', {highlight:true,selectable:true,editable:(editTableName != ""),sortable:true});

	if(typeof document.resForm != "object" || typeof document.resForm.ckr != "object")
		return;

	if (editTableName != "")
	{
		$('input').each( function() {
			if (this.type == "checkbox" && this.name != "ckrAll")
				$(this).click(function() { showNavBtn('delete'); });
			});
		editData = new Array();
		numEditRecords = 0;
	}
}

function postSortTable()
{
	if(document.resForm.ckr.length)
	{
		for(i=0; i<document.resForm.ckr.length; i++)
			document.resForm.ckr[i].checked = false;
	}
}