<?php

	/********************************************************************
	*	functions.php - Author: Samnan ur Rehman                         *
	*	This file is a part of MyWebSQL package                          *
	*	Core functions for server side mysql related functionality       *
	*	PHP5 compatible                                                  *
	*********************************************************************/

	function traceMessage($str)
	{
		if (TRACE_MESSAGES == 1)
		{
			ob_start();
				print_r($str);
				$str = ob_get_contents();
			ob_end_clean();
			error_log($str);
		}
	}

	function debugLog($str)
	{
		error_log($str);
	}

	function print_gzipped_output()
	{
		if (function_exists('ob_gzhandler'))
		{
			ob_end_flush();
			return true;
		}
		
		$HTTP_ACCEPT_ENCODING = $_SERVER["HTTP_ACCEPT_ENCODING"];
		if( headers_sent() )
			$encoding = false;
		else if( strpos($HTTP_ACCEPT_ENCODING, 'x-gzip') !== false )
			$encoding = 'x-gzip';
		else if( strpos($HTTP_ACCEPT_ENCODING,'gzip') !== false )
			$encoding = 'gzip';
		else
			$encoding = false;

		if( $encoding && function_exists("gzcompress") )
		{
			$contents = ob_get_clean();
			//traceMessage($contents);
			$_temp1 = strlen($contents);
			if ($_temp1 < 2048)		// no need to waste time in compressing very little data
				print($contents);
			else
			{
				header('Content-Encoding: '.$encoding);
				print("\x1f\x8b\x08\x00\x00\x00\x00\x00");
				$contents = gzcompress($contents, 9);
				$contents = substr($contents, 0, $_temp1);
				$_temp2 = strlen($contents);
				print($contents);
				traceMessage("$encoding: [$_temp1][$_temp2]");
			}
		}
		else
			ob_end_flush();
	}

	function matchFileHeader(&$str, $hdr)
	{
		if (is_array($hdr))
		{
			foreach($hdr as $v)
				if ( substr($str, 0, strlen($v)) == $v)
					return true;
		}
		else
			return  ( substr($str, 0, strlen($hdr)) == $hdr);

		return false;
	}

?>