<?php
	/********************************************************************
	*	Php Tree class - By Samnan ur Rehman  (25-01-2007)				*
	*	main features - very light and simple to use, and cool			*
	*	PHP5 compatible													*
	*	files required for use:											*
	*		iktree.css, js, php, ikte.gif, iktc.gif, ikn.gif			*
	*********************************************************************/

if (!defined("PHPTREE_INCLUDED"))
{
define("PHPTREE_INCLUDED", 1);

class TreeMenu
{
	var $nodeCount;			// this will be used to automatically set id of popup DIV
	var $indent;				// this will keep menu margin indentation
	var $menuWidth;			// width of menu (optional)
	var $expanded;
	var $showTips;
	var $showImages;
	var $imgPath;

	function __construct()
	{
		$this->TreeMenu();
	}

	function TreeMenu()
	{
		$this->nodeCount = 0;
		$this->indent = 0;
		$this->menuWidth = 150;
		$this->expanded = false;
		$this->showImages = true;
		$this->showTips = false;
		$this->imgPath  = "/images/";
		$this->prefix = "i_t_";
	}

	function setPrefix($pfx)
	{
		$this->prefix = $pfx;
	}

	function setImgPath($path)
	{
		$this->imgPath  = $path;
		if (substr($path, -1, 1) != "/")
			$this->imgPath .= "/";
	}

	function showTips($bool = true)
	{
		$this->showTips = $bool;
	}

	function showImages($bool = true)
	{
		$this->showImages = $bool;
	}

	function Start()
	{
		print "\n<script type=\"text/javascript\" language='javascript'> ikImgPath = \"$this->imgPath\"; </script>";
		print "\n<div style='width:$this->menuWidth;'><table class=\"iktTable\" cellpadding=0 cellspacing=1>";
		print "\n<tr><td></td></tr>";
	}

	function End()
	{
		print "\n</table></div>";
	}

	function NodeStart($caption, $imgName="", $expanded=-1)
	{
		$name = $this->prefix . "_pp_".$this->nodeCount;
		$img = $this->prefix.$this->nodeCount;;
		$margin = "margin-left:$this->indent"."px";
		$exp = $expanded === -1 ? $this->expanded : $expanded;

		$this->nodeCount += 1;
		$this->indent += 16;

		print "\n<tr><td nowrap=\"nowrap\">";
		print "<div class=\"iktPopup\" style=\"$margin\"><a href=\"javascript:ikToggle($img, $name)\"><img class='ikImg' align=middle border=0 id='$img' alt=\"\" src='$this->imgPath".
			($exp ? "iktc.gif'></a>" : "ikte.gif' /></a>");

		// show default node image if not given any custom image
		if ($this->showImages)
		{
			if (!$imgName)
				$imgName = "ikn.gif";
			print "<img class='ikImg2' border=\"0\" align=\"middle\" src='$this->imgPath". "$imgName' />";
		}

		print "$caption";
		print "</div>";
		print "</td></tr>";
		$tag = ($exp) ? "<tr><td><div id=\"$name\">" : "<tr><td><div id=\"$name\" style=\"display:none\">";
		print "\n$tag";
		print "<table border=0 cellpadding=0 cellspacing=1 width=100%>";
	}

	function NodeEnd()
	{
		print "\n</table></div></td></tr>";
		$this->indent -= 16;
	}

	function Item($caption, $url, $id="", $tip="", $imgName="", $rcMenu="")
	{
		$n = $this->indent + 14;

		if (!$this->showImages) $n += 3;		// extra indent with no image

		$margin = "margin-left:$n"."px";
		print "\n<tr><td nowrap=\"nowrap\"><a class=\"ikItem\" href=\"$url\" title=\"$tip\" onmousedown=\"ikMouseCheck(event, '$id')\">";
		print "<div id='$id' style=\"$margin\">";

		if ($this->showImages)
		{
			if ($imgName)
			{
				if (strpos($imgName, "/") === false)		// if img contains some path, we print it as is, otherwise use this->imgPath
					print "<img class='ikImg2' border=\"0\" alt=\"\" align=middle src='$this->imgPath". "$imgName'>";
				else
					print "<img class='ikImg2' border=\"0\" align=middle src='$imgName'>";
			}
		}

		if ($id)
			print "<span $menu>$caption<tbl id='$rcMenu' title='$caption' /></span>";
		else
			print "$caption";

		print "</div>";
		print "</a></td></tr>";
	}

	// additional utility functions
	function bulkItems($list, $nCaption, $nUrl, $imgName)
	{
		foreach($list as $k)
			$this->item($k[$nCaption], $k[$nUrl], "", $imgName);
	}
}
}
?>