<?php

	/********************************************************************
	*	interface.php - Author: Samnan ur Rehman						*
	*	This file is a part of MyWebSQL package							*
	*	Contains functions for rendering the GUI                        *
	*	PHP5 compatible													*
	*********************************************************************/

	function createMenuBar()
	{
		$menu = new menu();
		$menu->showImages(TRUE);
		$menu->setImgPath("themes/light/images/");		// if you want to change where menu images come from
		$menu->start();

			$menu->sectionStart("Database", "");
				$menu->item("Refresh", "dbRefresh()", "Refresh database objects", false);//, "mnu/rfsh.png");
				$menu->itemSeparator();
				$menu->item("Create new ...", "dbCreate()", "Create a new database", false);//, "mnu/rfsh.png");
				/*$menu->submenuStart("Submenu", "");
					$menu->subItem();
				$menu->submenuEnd();*/
			$menu->sectionEnd();

			$menu->sectionStart("Objects", "");
				$menu->item("Create Table...", "dbObjectCreate(0)", "Create a new table in the database", false);//, "mnu/table.png");
				$menu->item("Create View ...", "dbObjectCreate(1)", "Create a new view in the database", false);//, "mnu/view.png");
				$menu->item("Create Stored Procedure ...", "dbObjectCreate(2)", "Create a new stored procedure in the database", false);//, "mnu/proc.png");
				$menu->item("Create Function ...", "dbObjectCreate(3)", "Create a new user defined function in the database", false);//, "mnu/func.png");
				$menu->item("Create Trigger ...", "dbObjectCreate(4)", "Create a new trigger in the database", false);//, "mnu/trig.png");
			$menu->sectionEnd();

			$menu->sectionStart("Data", "");
				$menu->item("Import ...", "dataImport()", "Import queries from batch file", false);//, "mnu/import.png");
				$menu->item("Export ...", "dataExport()", "Export database to batch file as sql dump", false);//, "mnu/disk.png");
			$menu->sectionEnd();

			$menu->sectionStart("Results", "");
				$menu->item("Export ...", "resultsExport()", "Export query results to clipboard or files", false);//, "mnu/disk.png");
			$menu->sectionEnd();

			$menu->sectionStart("Tools", "");
				$menu->item("Options ...", "toolsOptions()", "Configure application options");
				$menu->itemSeparator();
				$menu->item("Process Manager", "toolsProcManager()", "View and manage database processes");
				$menu->item("Server variables", "toolsVariables()", "View mysql server variables");
			$menu->sectionEnd();

			$menu->barSeparator();
			$menu->addButton("bug.png", "Report a bug", "helpReportBug()", "If you have found a problem, or having trouble using the application, please click here to report the problem.");
			$menu->addButton("help.png", "Help", "helpShowAll()", "Learn basics of using the mywebsql interface");

		$menu->end();
	}

	function createDatabaseTree(&$db, $dblist)
	{
        global $HTML;
		if (getDbName())
		{
			$jsCode = "";

			print '<ul id="tablelist" class="filetree">';

			$tables = $db->getTables();
			print '<li><span class="tablef">Tables ('.count($tables).')</span>';
			if (count($tables) > 0)
			{
				foreach($tables as $key=>$table)
				{
					$tables[$key] = $id = $HTML->id($table);
                    $table = htmlspecialchars($table);
					print '<ul><li><span class="file" id="t_'.$id.'"><a href=\'javascript:tableSel("'.$id.'")\'>'.$table.'</a></span></li></ul>';
				}
				$jsCode .=
				"var db_tables = new Array(\"".implode("\",\"", $tables)."\");
				var mnu_ikMenuTable = [
					{'Select statement':function(menuItem,menuObject) { tableSelect($(this).text()); } },
					{'Insert statement':function(menuItem,menuObject) { tableInsert($(this).text()); } },
					{'Update statement':function(menuItem,menuObject) { tableUpdate($(this).text()); } },
					{'Describe':function(menuItem,menuObject) { tableDescribe($(this).text()); } },
					{'Show create command':function(menuItem,menuObject) { showCreateCmd('table', $(this).text()); } },
					{'View data':function(menuItem,menuObject) { tableViewData($(this).text()); } },
					{'Export ...':function(menuItem,menuObject) { tableExport($(this).text()); } },
                    \"context-menu-separator\",
                    {'More operations':function(menuItem,menuObject) { tableExport($(this).text()); } },
					\"context-menu-separator\",
					{'Create table ...':function(menuItem,menuObject) { dbObjectCreate(0); } }
					];\n";
			}
			print "</li>\n";

			$tables = $db->getViews();
			print '<li><span class="viewf">Views ('.count($tables).')</span>';
			if (count($tables) > 0)
			{
				foreach($tables as $key=>$table)
				{
					$tables[$key] = $id = $HTML->id($table);
					$table = htmlspecialchars($table);
					print '<ul><li><span class="file" id="t_'.$id.'"><a href=\'javascript:viewSel("'.$id.'")\'>'.$table.'</a></span></li></ul>';
				}
				$jsCode .=
				"var db_views = new Array(\"".implode("\",\"", $tables)."\");
				var mnu_ikMenuView = [
					{'Describe':function(menuItem,menuObject) { tableDescribe($(this).text()); } },
					{'Show create command':function(menuItem,menuObject) { showCreateCmd('view', $(this).text()); } },
					{'View data':function(menuItem,menuObject) { tableViewData($(this).text()); } },
					\"context-menu-separator\",
					{'Create view ...':function(menuItem,menuObject) { dbObjectCreate(1); } }
					];\n";
			}
			print "</li>\n";

			$tables = $db->getProcedures();
			print '<li><span class="procf">Procedures ('.count($tables).')</span>';
			if (count($tables) > 0)
			{
				foreach($tables as $key=>$table)
				{
					$tables[$key] = $id = $HTML->id($table);
					$table = htmlspecialchars($table);
					print '<ul><li><span class="file" id="t_'.$id.'"><a href=\'javascript:procSel("'.$id.'")\'>'.$table.'</a></span></li></ul>';
				}
				$jsCode .=
				"var db_procs = new Array(\"".implode("\",\"", $tables)."\");
				var mnu_ikMenuProc = [
					{'Show create command':function(menuItem,menuObject) { showCreateCmd('procedure', $(this).text()); } },
					\"context-menu-separator\",
					{'Create procedure ...':function(menuItem,menuObject) { dbObjectCreate(2); } }
					];\n";
			}
			print "</li>\n";

			$tables = $db->getFunctions();
			print '<li><span class="funcf">Functions ('.count($tables).')</span>';
			if (count($tables) > 0)
			{
				foreach($tables as $key=>$table)
				{
					$tables[$key] = $id = $HTML->id($table);
					$table = htmlspecialchars($table);
					print '<ul><li><span class="file" id="t_'.$id.'"><a href=\'javascript:funcSel("'.$id.'")\'>'.$table.'</a></span></li></ul>';
				}
				$jsCode .=
				"var db_funcs = new Array(\"".implode("\",\"", $tables)."\");
				var mnu_ikMenuFunc = [
					{'Show create command':function(menuItem,menuObject) { showCreateCmd('function', $(this).text()); } },
					\"context-menu-separator\",
					{'Create function ...':function(menuItem,menuObject) { dbObjectCreate(3); } }
					];\n";
			}
			print "</li>\n";

			$tables = $db->getTriggers();
			print '<li><span class="trigf">Triggers ('.count($tables).')</span>';
			if (count($tables) > 0)
			{
				foreach($tables as $key=>$table)
				{
					$tables[$key] = $id = $HTML->id($table);
					$table = htmlspecialchars($table);
					print '<ul><li><span class="file" id="t_'.$id.'"><a href=\'javascript:trigSel("'.$id.'")\'>'.$table.'</a></span></li></ul>';
				}
				$jsCode .=
				"var db_trigs = new Array(\"".implode("\",\"", $tables)."\");
				var mnu_ikMenuTrig = [
					{'Show create command':function(menuItem,menuObject) { showCreateCmd('trigger', $(this).text()); } },
					\"context-menu-separator\",
					{'Create trigger ...':function(menuItem,menuObject) { dbObjectCreate(4); } }
					];\n";
			}
			print "</li>\n";

			print '</ul>';

			if ($jsCode)
				print "<script language=\"JavaScript\" type=\"text/javascript\"> $jsCode </script>";

			return TRUE;
		}
		else
		{
			print '<ul class="dblist">';
			foreach($dblist as $dbname)
				print '<li><span class="dbf"><a href="javascript:selectDatabase(\''.$dbname.'\')">'.htmlspecialchars($dbname).'</a></span>';
			print '</ul>';
		}
	}

	function createContextMenus()
	{
		$historyMenu = "var mnu_editHst = [
					{'Copy all queries to clipboard':function(menuItem,menuObject) { historyCopy($(this)); } },
					{'Clear history':function(menuItem,menuObject) { historyClear(menuObject); } }
					];\n";
		print "<script language=\"JavaScript\" type=\"text/javascript\"> $historyMenu </script>";
	}

	function getSqlEditorType()
	{
		return (SQL_EDITORTYPE == "codemirror") ? 1 : 0;
	}

	function updateSqlEditor(&$html)
	{
		if (SQL_EDITORTYPE == "codemirror")
		{
			// saveFunction, autoMatchParens
			print "<script type=\"text/javascript\" language=\"javascript\" src=\"cache.php?script=editor/codemirror\"></script><script type=\"text/javascript\" language=\"javascript\">
					$(function() {
						commandEditor = CodeMirror.fromTextArea('commandEditor', { iframeClass: 'sqlEditFrame', parserfile: 'mysql.js', height: '95%',
						tabMode : 'default',
						stylesheet: 'cache.php?css=mysqlcolors', path: 'js/editor/', initCallback : function() { initStart(); },
						tabFunction : function() { document.getElementById('nav_query').focus(); } });
					});
					</script>";
		}
	}
?>