<?php

	/********************************************************************
	*	menu.php - Author: Danish Zahur									*
	*	This file is a part of MyWebSQL package							*
	*	Creates a cool looking GUI toolbar and menu 					*
	*	PHP5 compatible													*
	*********************************************************************/

if (!defined("CLASS_MENU_INCLUDED"))
{
	define("CLASS_MENU_INCLUDED", "1");

	class menu
	{
		var $menuItem;
		var $submenuItem;
		var $subMenuDefination;
		var $toolbar;
		var $imgPath;
		var $showImages;

		function __construct() // For php5 compatibility
		{
			$this->menu();
		}

		function menu() // For php4 compatibility
		{
			$this->itemId = 0;
			$this->submenuItem = 0;
			$this->subMenuDefination = "";
			$this->toolbar = array();
			$this->showImages = false;
		}

		function showImages($bool=TRUE)
		{
			$this->showImages = $bool;
		}

		function setImgPath($path)
		{
			$this->imgPath  = $path;
			if (substr($path, -1, 1) != "/")
				$this->imgPath .= "/";
		}

		function start()
		{
			print "<div class='toolbar ui-dialog-titlebar ui-widget-header ui-corner-all ui-helper-clearfix'>\n";
		}

		function end()
		{
			if(count($this->toolbar) > 0)
			{
				print '<div style="float:'. RIGHT_ALIGN .'">';
				foreach($this->toolbar as $toolbarItem)
				{
					if($toolbarItem['type'] === "button")
					{
						print '<div style="float:'. LEFT_ALIGN .'" onclick=\'menuOnClickHandler("'. addslashes($toolbarItem['funcWithParam']) .'")\' onmousedown=\'$(this).addClass("toolbar-button_active")\' onmouseup=\'$(this).removeClass("toolbar-button_active")\' onmouseover=\'$(this).addClass("toolbar-button_hover")\' onmouseout=\'$(this).removeClass("toolbar-button_hover")\' class="toolbar-button"'. (($toolbarItem['desc']) ? ' title="'. $toolbarItem['desc'] .'" ' : ' ') .'>';
						print "<img src=\"$this->imgPath". $toolbarItem['image'] . "\" align=\"middle\" alt=\"\" />";
						if($toolbarItem['caption'])
							print '<span>'.$toolbarItem['caption'].'</span>';
							//print '<span align=middle style="padding:0px 5px 0px 5px;">'. $toolbarItem['caption'] .'</span>';
						print '</div>' . "\n";
					}
					else
					{
						print '<div style="FLOAT:'. LEFT_ALIGN .'">';
						print "<img src=\"$this->imgPath". "separator.gif\" width=\"7\" height=\"19\" alt=\"\" align=\"middle\" />\n";
						print '</div>' . "\n";
					}

				}
				print '</div>';
			}

			print ($this->subMenuDefination);
			print '</div>' . "\n";
		}

		function sectionStart($caption, $desc="", $id="")
		{
			if ($id == "")
				$id = $this->itemId;

			print '<div style="float:'. LEFT_ALIGN .'">';
				print '<table cellspacing="0" cellpadding="0">' . "\n";
					print '<tr>' . "\n";
						print '<td>' . "\n";
							print '<div style="float:'. LEFT_ALIGN .'" id="menuButton'. $id .'" onclick="toggleMenu(\''. $id .'\')" onmouseover="menuHover(\''. $id .'\')" onmouseout="menuHout(\''. $id .'\')" title="'. $desc .'" class="menu-button">'. $caption .'</div>' . "\n";
						print '</td>' . "\n";
					print '</tr>' . "\n";
					print '<tr>' . "\n";
						print '<td>' . "\n";
							print '<div id="menuItem'. $id .'" class="menu-body" style="position:absolute;display:none;">' . "\n";
								print '<table cellspacing="0" cellpadding="0" class="outer-border">' . "\n";
									print '<tr class="inner-border">' . "\n";
										print '<td class="menu-body">' . "\n";
			$this->itemId++;
		}

		function sectionEnd()
		{
										print '</td>' . "\n";
									print '</tr>' . "\n";
								print '</table>' . "\n";
							print '</div>' . "\n";
						print '</td>' . "\n";
					print '</tr>' . "\n";
				print '</table>' . "\n";
			print '</div>' . "\n";
		}

		function item($caption, $funcWithParam, $desc="", $disable=FALSE, $img="")
		{
			print "<div onmouseover='menuItemHover(this)' onmouseout='menuItemHout(this)' onclick='menuOnClickHandler(\"" . addslashes($funcWithParam) ."\")'". (($desc) ? ' title="'. $desc .'" ' : '');
			if($disable)
				print " class='disabled'";
			else
				print " class='ikCMenuItm'";


			if ($img != "" && $this->showImages)
				print " style='padding-left:3px'><img width=\"14\" height=\"13\" src=\"$this->imgPath". $img . "\" alt=\"\" align=\"middle\" /><span style='padding-left:15px'>$caption</span>";
			else
				print " style='padding-left:32px'>$caption";

			print "</div>" . "\n";
		}

		function submenuStart($caption, $desc="")
		{
			print '<div id="subSection'. $this->submenuItem .'" onmouseover="showSubMenu(this, \''. $this->submenuItem .'\')" onmouseout="menuCloseOnClick=true;" title="'. $desc .'" CLASS="subMenu">'. $caption .'</DIV>' . "\n";

			ob_start();
			print '<div id="submenuItem'. $this->submenuItem .'" class="menu-body", style="position:absolute;display:none;">' . "\n";
				print '<table cellspacing=1 cellpadding=0 class="outer-border">' . "\n";
						print '<tr class="inner-border">' . "\n";
							print '<td CLASS="menu-body">' . "\n";
			$this->submenuItem++;
		}

		function submenuEnd()
		{
						print '</td>' . "\n";
					print '</tr>' . "\n";
				print '</table>' . "\n";
			print '</div>' . "\n";

			$this->subMenuDefination .= ob_get_contents();
			ob_end_clean();
		}

		function subItem($caption, $funcWithParam, $desc="", $disable=FALSE)
		{
			print "<div onmouseover='menuItemHover(this, true)' onmouseout='menuItemHout(this)' onclick='menuOnClickHandler(\"" . addslashes($funcWithParam) ."\")'". (($desc) ? ' title="'. $desc .'" ' : '');
			if($disable)
				print " class='disabled'>";
			else
				print " class='ikCMenuItmH'>";
			print $caption ."</div>" . "\n";
		}

		function itemSeparator()
		{
			print '<div class="ikCMenuItmSep">' . "\n";
				print '<div class="separator-line">' . "\n";
				print '</div>' . "\n";
			print '</div>' . "\n";
		}

		function addButton($image, $caption="", $funcWithParam, $desc="")
		{
			$this->toolbar[] = array("type" => "button", "image" => $image, "funcWithParam" => $funcWithParam, "caption" => $caption, "desc" => $desc, "dropdown"=>'');
		}

		function barSeparator()
		{
			$this->toolbar[] = array("type" => "seprator");
		}
	}
}
?>