<?php

	/**********************************************
	*	auth.php - Author: Samnan ur Rehman        *
	*	This file is a part of MyWebSQL package    *
	*	PHP5 compatible                            *
	**********************************************/

	class MyWebSql_Authentication
	{
		private $error;
		private $username;
		private $password;
		private $db;

		public function authenticate($DB)
		{

			$this->db = $DB;
			$error = '';
			$username = '';
			$password = '';

			// chnage of auth type at runtime invalidates session
			if (v($_SESSION["auth_type"]) != AUTH_TYPE)
				unset($_SESSION["init"]);

			if (v($_SESSION["init"]) === 1)
				return $this->setParameters();

			if (!$this->checkEnvironment())
				return false;

			if (AUTH_TYPE == 'NONE')
			{
				$_SESSION["init"] = 1;
				return $this->setParameters();
			}

			if (AUTH_TYPE == 'BASIC')
				$this->getAuthBasic();
			else if (AUTH_TYPE == 'LOGIN')
				$this->getAuthLogin();

			if (v($_SESSION["init"]) === 1)
				return $this->setParameters();

			return false;
			/*
			if (is_array($DB_CONFIG) && count($DB_CONFIG) > 0)
			{
				if (isset($_REQUEST["conn"]))
				{
					if (isset($DB_CONFIG[$_REQUEST["conn"]]))
					{
						$_SESSION["conn"] = $_REQUEST["conn"];
						$_SESSION["dblist"] = false;	// if db is set, user will be restricted to this db only
						if (isset($DB_CONFIG[$_REQUEST["conn"]]["db"]))
							$_SESSION["db"] = $DB_CONFIG[$_REQUEST["conn"]]["db"];
						else
						{
							$_SESSION["db"] = "";
							$_SESSION["dblist"] = true;		// show all databases
						}
						$_SESSION["init"] = 1;
					}
				}
				if (v($_SESSION["init"]) != 1)
				{
					include("modules/splash.php");
					die(getSplashScreen());
				}
			}
			else
			{
				$_SESSION["init"] = 1;
				include("modules/splash.php");
				die(getSplashScreen());
			}*/
		}

		public function getError()
		{
			return $this->error;
		}

		private function setError($str)
		{
			$this->error = $str;
			return false;
		}


		private function checkEnvironment()
		{
			if ( !defined('AUTH_SERVER') || AUTH_SERVER == '' )
				return $this->setError('Invalid server configuration');

			if ( !defined('AUTH_TYPE') || !(AUTH_TYPE == 'NONE' || AUTH_TYPE == 'BASIC' || AUTH_TYPE == 'LOGIN') )
				return $this->setError('Invalid server configuration');

			return true;
		}

		private function setParameters()
		{
			$host = AUTH_SERVER;
			$username = $password = '';
			switch(AUTH_TYPE)
			{
				case 'NONE':
					$username = AUTH_LOGIN;
					$password = AUTH_PASSWORD;
					break;
				case 'BASIC':
				case 'LOGIN':
					$username = $_SESSION['auth_user'];
					$password = $_SESSION['auth_pwd'];
					break;
			}

			define("DB_HOST", $host);
			define("DB_USER", $username);
			define("DB_PASS", $password);

			$_SESSION['auth_type'] = AUTH_TYPE;

			return true;
		}

		private function getAuthBasic()
		{
			if (isset($_SERVER['PHP_AUTH_USER']) && isset($_SERVER['PHP_AUTH_PW']))
			{
				if ($this->db->connect(AUTH_SERVER,$_SERVER['PHP_AUTH_USER'],$_SERVER['PHP_AUTH_PW']))
				{
					$_SESSION["init"] = 1;
					$_SESSION['auth_user'] = $_SERVER['PHP_AUTH_USER'];
					$_SESSION['auth_pwd'] = $_SERVER['PHP_AUTH_PW'];
					return true;
				}
				else
					$this->setError('Invalid Credentials');
			}

			header('WWW-Authenticate: Basic realm="MyWebSql"');
			header('HTTP/1.0 401 Unauthorized');
			echo 'Invalid Credentials supplied';

			return false;
		}

		private function getAuthLogin()
		{
			if (isset($_POST['auth_user']) && isset($_POST['auth_pwd']))
			{
				if ($this->db->connect(AUTH_SERVER,$_POST['auth_user'],$_POST['auth_pwd']))
				{
					$_SESSION["init"] = 1;
					$_SESSION['auth_user'] = $_POST['auth_user'];
					$_SESSION['auth_pwd'] = $_POST['auth_pwd'];
					return true;
				}
				else
					$this->setError('Invalid Credentials');
			}

			$form = '<div class="auth"><div><label>User ID:</label><input type="text" name="auth_user" size="30" value="'.htmlspecialchars(v($_POST['auth_user'])).'"/></div><div><label>Password:</label><input type="password" name="auth_pwd" size="30" /></div><div><input type="submit" value="  Login  " /></div></div>';
			include("modules/splash.php");
			die(getSplashScreen($this->getError(), $form));
		}
	}
?>