<?php

	/********************************************************************
	*	download.php - Author: Samnan ur Rehman							*
	*	This file is a part of MyWebSQL package							*
	*	PHP5 compatible													*
	*********************************************************************/
	
	// exptype
	// 1=insert queries
	// 2=plain text (one record perline)

	function handleDownload(&$db)
	{
		if ($_REQUEST["id"] == "exportres")
			downloadResults($db);
		if ($_REQUEST["id"] == "exporttbl")
			downloadTable($db, $_REQUEST["name"]);
		if ($_REQUEST["id"] == "export")
			downloadDatabase($db);
	}
	
	function downloadResults(&$db)
	{
		$autof = -1;
		// find auto increment key from the result table (if any and one)
		// and query is of 'select' type
		if (substr($_SESSION["query"], 0, 6) == "select" && $_REQUEST["autokeys"] == "on" && $_SESSION["table"] != "")
			$autof = getAutoIncField($db, $_SESSION["table"]);
		
		$fname = ($_SESSION["table"] != "") ? $_SESSION["table"] . "-results.sql" : "results.sql";
		
		if ($_REQUEST["dlfile"] == "on")
			header("Content-disposition: attachment;filename=$fname");
		else
			print "<html><body><textarea style='width:100%;height:99%'>";
		
		downloadCommon($db, $_SESSION["query"], $_SESSION["table"], $autof);
		
		if ($_REQUEST["dlfile"] == "on")
			;
		else
			print "</textarea><body></html>";
	}
	
	function downloadTable(&$db, $table)
	{
		if ($table == "")
			return false;
	
		$autof = -1;
		if ($_REQUEST["autokeys"] == "on")
			$autof = getAutoIncField($db, $table);
		
		$sql = "select * from `".$table."`";
		header("Content-disposition: attachment;filename=".$table.".sql");
		downloadCommon($db, $sql, $table, $autof);
	}
	
	
	function downloadDatabase(&$db)
	{
		// dont make POST as REQUEST here. it doesnt work :P
		if (!is_array($_POST["tablelist"]))
			return false;

		$sql = "show full tables from `".$_SESSION["db"]."`";
		if (!$db->query($sql))
			return false;
		
		$tlist = array();
		while($r = $db->fetchRow())
			$tlist[] = array($r[0], $r[1]);
	
		header("Content-disposition: attachment;filename=".$_SESSION["db"].".sql");
		print "/* Database export results for db ".$_SESSION["db"]."*/\n\n";
		
		foreach($tlist as $tinfo)
		{
			if ($tinfo[1] != "BASE TABLE")		// for now, we only export tables
				continue;
			
			// is this table required in export?
			$key = array_search($tinfo[0], $_POST["tablelist"]);
			if ($key === FALSE)
				continue;
			
			// -- -drop command --
			if ($_REQUEST["dropcmd"] == "on")
			{
				print "drop table if exists $tinfo[0];\n\n";
			}
			
			// -- -structure --
			$type = "table";
			if ($_REQUEST["createcmd"] == "on")
			{
				print "/* table structure for $r[0] */\n";
				$sql = "show create $type `$tinfo[0]`";
				if (!$db->query($sql, "_create") || $db->numRows("_create") == 0)
					print "/* Failed to retrieve $type structure for $tinfo[0] */";
				else
				{
					if ($type == "table" || $type == "view")
						$num = 1;
					else
						$num = 2;
					$row = $db->fetchRow("_create");
					print $row[$num] . ";\n";
				}
			}
			
			// -- -table data --
			$autof = -1;
			if ($_REQUEST["autokeys"] == "on")
				$autof = getAutoIncField($db, $r[0]);
			
			$sql = "select * from `".$tinfo[0]."`";
			print "/*\n data for table $tinfo[0] */\n";
			
			downloadCommon($db, $sql, $tinfo[0], $autof);
			
			print "\n";
		}
	}
	
	// =====================================
	function getAutoIncField(&$db, $table)
	{
		$sql = "show full fields from `".$table."`";
			if (!$db->query($sql, "_temp"))
				return false;
				
		$i = 0;
		while($row = $db->fetchRow("_temp"))
		{
			if (strpos($row["Extra"], "auto_increment") !== false)
			{
				traceMessage("auto inc field [$table] = $i");
				return $i;
			}
			$i++;
		}
		
		return -1;
	}
	
	// common download function for all types of exports
	function downloadCommon(&$db, $sql, $table, $autof=-1)
	{
		$exp = $_REQUEST["exptype"];
		if ($exp < 1 || $exp > 2)
			$exp = 1;
		
		traceMessage("downloadCommon($sql, $table, $autof, $exp)");
		
		$applyLimit = strpos($sql, "limit ") || ("select" != strtolower(substr($sql, 0, 6)));
		
		$id = 0;
		while(1)
		{
			$tempSql = $sql;
			if ($applyLimit == false)
				$tempSql .= " limit $id, 100";

			if (!$db->query($tempSql, "_temp"))
				return false;

			$res = "";
			$f = $db->getFieldInfo("_temp");
			
			$numRows = $db->numRows("_temp");
		
			while($row = $db->fetchRow("_temp", MYSQL_NUM))
			{
				if ($exp == 1)
					createInsertLine($db, $row, $res, $autof, $table);
				else if ($exp == 2)
					createSimpleLine($db, $row, $res);
			}
			
			print $res;
			unset($res);
			
			if ($numRows == 0 || $applyLimit)
				break;
				
			$id += 100;
		}
	}
	
	function createInsertLine(&$db, &$row, &$res, $autof, $table)
	{
		$x = count($row);
		$res .= "insert into `".$table."` values (";
		for($i=0; $i<$x; $i++)
		{
			if ($autof == $i)
				$res .= "NULL";
			else if ($row[$i] === NULL)
				$res .= "NULL";
			else if ($f[$i]->numeric == 1)
				$res .= $row[$i];
			else
				$res .= "\"". $db->escape($row[$i]) . "\"";
			
			if ($i+1 == $x)
				$res .= ");\r\n";
			else
				$res .= ",";
		}
	}
	
	function createSimpleLine(&$db, &$row, &$res)
	{
		$x = count($row);
		for($i=0; $i<$x; $i++)
		{
			if ($row[$i] === NULL)
				$res .= "NULL";
			else if ($f[$i]->numeric == 1)
				$res .= $row[$i];
			else
				$res .= $_REQUEST["csv_field"] .  $row[$i] . $_REQUEST["csv_field"];
			
			if ($i+1 == $x)
				$res .= "\r\n";
			else
				$res .= "\t";
		}
	}
?>