<?php

	/********************************************************************
	*	objectcreate.php - Author: Samnan ur Rehman						*
	*	This file is a part of MyWebSQL package							*
	*	PHP5 compatible													*
	*********************************************************************/

	function processRequest(&$db)
	{
		// html and form is started by calling function
		print "<link href='cache.php?css=theme,default' rel=stylesheet />\n";
		print "<div class='scrinfo'>";
		
		$type = "warning";
		if (isset($_REQUEST["objinfo"]))
		{
			$msg = createDatabaseObject($db, $_REQUEST["id"], $_REQUEST["objinfo"]);
			if (!$msg)		// msg will be returned only if error (bad programming guys, dont learn from it !)
			{
				$msg = "The command executed successfully.";
				$type = "notice";
			}
			else
				$type="error";
		}
		else
			$msg = "Any existing object with the same name should be dropped manually before executing the creation command !";
			displayCreateObjectForm($msg, $type);
		print "</div>";
		
		print "<script type=\"text/javascript\" language='javascript'> parent.updatePopupTitle('Create new database object'); </script>";
	}
	
	function displayCreateObjectForm($msg, $type="warning")
	{
		$icon = $type == 'warning' || $type == 'notice' ? 'ui-icon-info' : 'ui-icon-error';
		$div = '<div class="ui-widget ui-state-highlight ui-corner-all" style="padding:5px"><span class="ui-icon '.$icon.'"></span>'.$msg.'</div>';
	
		print "<input type='hidden' name='q' value='wrkfrm' />";
		print "<input type='hidden' name='type' value='objcreate' />";
		print "<input type='hidden' name='id' value='$_REQUEST[id]' />";
		print "<table border=0 cellspacing=2 cellpadding=2>";
		print "<tr><td>$div</td></tr>";
		print "<tr><td colspan=2>Enter command for object creation</td></tr>";
		print "<tr><td colspan=2 align=right><textarea cols=60 rows=18 name='objinfo' class='textEditor'>";
		if (isset($_REQUEST["objinfo"]))
			print htmlspecialchars($_REQUEST["objinfo"]);
		else
			print getObjectCreateCommand($_REQUEST["id"]);
		print "</textarea></td></tr>";
		print "<tr><td colspan=2 align=right><input type='submit' name='btn' value='   Submit   ' onclick='document.frmquery.submit();'/></td></tr>";
		
		print "<script type=\"text/javascript\" language='javascript'> frmquery.objinfo.focus(); </script>";
	}
	
	function getObjectCreateCommand($id)
	{
		if ($id == 0)
			$x = "CREATE TABLE new_table_1\n(fields ...)\nTYPE=MYISAM";
		else if ($id == 1)
			$x = "
CREATE
    /*[ALGORITHM = {UNDEFINED | MERGE | TEMPTABLE}]
    [DEFINER = { user | CURRENT_USER }]
    [SQL SECURITY { DEFINER | INVOKER }]*/
    VIEW `new_view_1`
    AS
    (SELECT * FROM ...)";
		else if ($id == 2)
			$x = "CREATE
    /*[DEFINER = { user | CURRENT_USER }]*/
    PROCEDURE `new_proc_1` ()
    /*LANGUAGE SQL
    | [NOT] DETERMINISTIC
    | { CONTAINS SQL | NO SQL | READS SQL DATA | MODIFIES SQL DATA }
    | SQL SECURITY { DEFINER | INVOKER }
    | COMMENT 'string'*/
    BEGIN

    END";
		else if ($id == 3)
			$x = "
CREATE
    /*[DEFINER = { user | CURRENT_USER }]*/
    FUNCTION `new_func_1` ()
    RETURNS type
    /*LANGUAGE SQL
    | [NOT] DETERMINISTIC
    | { CONTAINS SQL | NO SQL | READS SQL DATA | MODIFIES SQL DATA }
    | SQL SECURITY { DEFINER | INVOKER }
    | COMMENT 'string'*/
    BEGIN

    END";
		else if ($id == 4)
		$x = "
CREATE
    /*[DEFINER = { user | CURRENT_USER }]*/
    TRIGGER `new_trig_1` BEFORE/AFTER INSERT/UPDATE/DELETE
    ON `<table>`
    FOR EACH ROW BEGIN

    END";
		return htmlspecialchars($x);
	}
	
	function createDatabaseObject(&$db, $id, $info)
	{
		$cmd = trim($info);
		if (strtolower(substr($cmd, 0, 6)) != "create")
			return "Only create commands are accepted";
		
		if (!$db->query($cmd))
			return htmlspecialchars($db->getError());
		
		return "";
	}


?>